#!/usr/bin/perl

use strict;
use warnings;

my @res = qw/convert interlace merge shadeboost tfx/;
my $path = "plugins/GSdx/res";

foreach my $r (@res) {
    glsl2h($path, $r);
}

sub glsl2h {
    my $path = shift;
    my $glsl = shift;

    open(my $GLSL, "<$path/${glsl}.glsl");
    open(my $H, ">$path/${glsl}.h");

    my $header = <<EOS;
/*
 *	Copyright (C) 2011-2013 Gregory hainaut
 *	Copyright (C) 2007-2009 Gabest
 *
 *  This file was generated by glsl2h.pl script
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA USA.
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */

#pragma once

#include "stdafx.h"

extern const char* ${glsl}_glsl =
EOS

    print $H $header;

    my $line;
    while(defined($line = <$GLSL>)) {
        chomp $line;
        $line =~ s/%/\\%/g;
        $line =~ s/"/\\"/g;
        print $H "\t\"$line\\n\"\n";
    }
    print $H "\t;\n";
}
